/*
    semu - Sega Saturn Emulator
    Copyright (C) 1998  Chuck Mason

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Chuck Mason IV                      chuckjr@sundial.net
    477 Moffat Loop
    Oviedo, Fl 32765
*/

#ifndef __BIOS_H
#define __BIOS_H

#define SEGA_MAGIC "SEGA SEGASATURN "

extern char *cddevice;
extern char *romfile;

extern unsigned char sega_security_code[];
extern unsigned long int sega_security_code_size;

extern unsigned char area_code_us[];
extern unsigned long int area_code_us_size;

extern FILE *saturn_cdrom_file;
extern int saturn_cdrom;

int emulate_bios(char *cddev); /* afaik this will start the mail loop */

int confirm_security();
int confirm_unitedstates_security();

#ifndef DOS
int cdrom_play_track(int start);
#endif


#endif
