/*
    semu - Sega Saturn Emulator
    Copyright (C) 1998  Chuck Mason

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Chuck Mason IV                      chuckjr@sundial.net
    477 Moffat Loop
    Oviedo, Fl 32765
*/

#include <stdio.h>
#include <stdlib.h>
#include "opcodes.h"

instruction_list sh2_instructions[65536];

instruction_list sh2_find_opcode(unsigned long opcode)
{
	unsigned long int x;
	instruction_list bad = { 0, 0, 0, sh2_opcode_invalid, "UNIMPLEMENTED/INVALID" };
	
	for(x = 0; x != OPCODE_COUNT; x++) {
		if((sh2_instruction_list[x].mask & opcode) == sh2_instruction_list[x].opcode)
			return sh2_instruction_list[x];
	}
	return bad;
}
		
void sh2_build_instruction_list()
{
	unsigned long optest;
	unsigned good, bad;

	for(optest = 0; optest <= 0xFFFF; optest++) 
		sh2_instructions[optest] = sh2_find_opcode(optest);
	
	for(optest = 0, good = 0, bad = 0; optest <= 0xFFFF; optest++) {
		if(sh2_instructions[optest].execute != sh2_opcode_invalid)
			good++;
		else
			bad++;
	}

	printf("SH2: %d/%d implemented opcodes.\n", OPCODE_COUNT, TOTAL_OPCODE_COUNT);
	printf("SH2: %d unimplemented opcodes.\n", TOTAL_OPCODE_COUNT - OPCODE_COUNT);
	printf("SH2: %d/65536 instructions available.\n", good);
	printf("SH2: %d unimplemented accesses.\n", bad);

}