/*
    semu - Sega Saturn Emulator
    Copyright (C) 1998  Chuck Mason

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Chuck Mason IV                      chuckjr@sundial.net
    477 Moffat Loop
    Oviedo, Fl 32765
*/

#ifndef __FORMATS_H
#define __FORMATS_H

#define X_FORMAT 	0 	/* xxxx xxxx xxxx xxxx */
#define N_FORMAT 	1 	/* xxxx nnnn xxxx xxxx */
#define M_FORMAT 	2 	/* xxxx mmmm xxxx xxxx */
#define NM_FORMAT 	3 	/* xxxx nnnn mmmm xxxx */
#define MD_FORMAT	4	/* xxxx xxxx mmmm dddd */
#define ND4_FORMAT	5	/* xxxx xxxx nnnn dddd */
#define NMD_FORMAT	6	/* xxxx nnnn mmmm dddd */
#define D_FORMAT	7	/* xxxx xxxx dddd dddd */
#define D12_FORMAT	8	/* xxxx dddd dddd dddd */
#define ND8_FORMAT	9	/* xxxx nnnn dddd dddd */
#define I_FORMAT	10	/* xxxx xxxx iiii iiii */
#define NI_FORMAT	11	/* xxxx nnnn iiii iiii */

typedef struct _opx {
	short int padding;
} opx;

typedef struct _opn {
	unsigned char padding2;
	unsigned char dest:4;
	unsigned char padding:4;
} opn;

typedef struct _opm {
	unsigned char padding2;
	unsigned char source:4;
	unsigned char padding:4;
} opm;

typedef struct _opnm {
	unsigned char padding2:4;
	unsigned char source:4;
	unsigned char dest:4;
	unsigned char padding:4;
} opnm;

typedef struct _opmd {
	unsigned char disp:4;
	unsigned char source:4;
	unsigned char padding;
} opmd;

typedef struct _opnd4 {
	unsigned char disp:4;
	unsigned char dest:4;
	unsigned char padding;
} opnd4;

typedef struct _opnmd {
	unsigned char disp:4;
	unsigned char source:4;
	unsigned char dest:4;
	unsigned char padding:4;
} opnmd;

typedef struct _opd {
	unsigned char disp;
	unsigned char padding;
} opd;

typedef struct _opd12 {
	short int disp:12;
	unsigned char padding:4;
} opd12;

typedef struct _opnd8 {
	unsigned char disp;
	unsigned char dest:4;
	unsigned char padding:4;
} opnd8;

typedef struct _opi {
	unsigned char imm;
	unsigned char padding;
} opi;

typedef struct _opni {
	unsigned char imm;
	unsigned char dest:4;
	unsigned char padding:4;
} opni;

typedef union {
	short int opcode;
	opx   x;
	opn   n;
	opm   m;
	opnm  nm;
	opmd  md;
	opnd4 nd4;
	opnmd nmd;
	opd   d;
	opd12 d12;
	opnd8 nd8;
	opi   i;
	opni  ni;
} instruction;

#endif