/*
    semu - Sega Saturn Emulator
    Copyright (C) 1998  Chuck Mason

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Chuck Mason IV                      chuckjr@sundial.net
    477 Moffat Loop
    Oviedo, Fl 32765
*/

#include <stdio.h>
#include <stdlib.h>

#include "sh2proc.h"

sh2_processor sh2;

short int sh2_invalid_opcode_occ = 0;
short int sh2_processor_sleep = 0;

void sh2_reset_cpu()
{
	int i;
	
	for(i = 0; i < 16; i++) 
		sh2.R[i] = 0;
	
	
	sh2.SR = 0x0F;
	sh2.VBR = 0;
	sh2.MACH = 0;
	sh2.MACL = 0;
	sh2.PR = 0;
	sh2.PC = 0;
	
	sh2_invalid_opcode_occ = 0;
	sh2_processor_sleep = 0;
	printf("SH2 Processor reset.\n");

}
