/*
    semu - Sega Saturn Emulator
    Copyright (C) 1998  Chuck Mason

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Chuck Mason IV                      chuckjr@sundial.net
    477 Moffat Loop
    Oviedo, Fl 32765
*/

#ifndef __SH2PROC_H
#define __SH2PROC_H

typedef struct __sh2_proc {
	unsigned long R[16];
	unsigned long SR, GBR, VBR;
	unsigned long MACH, MACL, PR;
	unsigned long PC;
} sh2_processor;

extern sh2_processor sh2;

struct sh2_SR0 {
        unsigned long dummy0 : 22;
        unsigned long M0 : 1;
        unsigned long Q0 : 1;
        unsigned long I0 : 4;
        unsigned long dummy1 : 2;
        unsigned long S0 : 1;
        unsigned long T0 : 1;
};

/* Definitions of BITS in SR */
#define M ((*(struct sh2_SR0 *)(&(sh2.SR))).M0)
#define Q ((*(struct sh2_SR0 *)(&(sh2.SR))).Q0)
#define S ((*(struct sh2_SR0 *)(&(sh2.SR))).S0)
#define T ((*(struct sh2_SR0 *)(&(sh2.SR))).T0)

extern short int sh2_invalid_opcode_occ;
extern       int sh2_in_debugger;
extern short int sh2_processor_sleep;

void sh2_reset_cpu();
int sh2_debugger(unsigned long); 	/* In debug.c */

#endif