/*
    semu - Sega Saturn Emulator
    Copyright (C) 1998  Chuck Mason

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Chuck Mason IV                      chuckjr@sundial.net
    477 Moffat Loop
    Oviedo, Fl 32765
*/

#include <stdio.h>
#include <stdlib.h>
#include "opcodes.h"
#include "sh2proc.h"

int main(int argc, char *argv[])
{
	FILE *fp;	
	unsigned long len, i;

	printf("SH-2 CPU Test by Chuck Mason (chuckjr@sundial.net)\n");
	printf("This CPU core is part of semu. This program was made\n");
	printf("to demonstrate the progress that I am having with semu.\n\n");

	if(argc != 2) {
		printf("\nUsage: %s [rom file]\n", argv[0]);
		printf("[rom file] can be any kind of file. This program will\n");
		printf("try to execute it in the sh2 cpu.\n");
		return 1;
	}
	
	if((fp = fopen(argv[1], "rb")) == NULL) {
		printf("Cannot open %s!\n", argv[1]);
		return 1;
	}
	
	fseek(fp, 0, SEEK_END);
	len = ftell(fp);
	rewind(fp);
	
	for(i = 1; i <= len; i++) {
		unsigned char c;
		c = fgetc(fp);
		sh2_write_byte(i - 1, c);
	}
	
	fclose(fp);

	
	sh2_build_instruction_list();
	sh2_reset_cpu();
		
	sh2_debugger(len);
	
	return 0;
}
