/*
    semu - Sega Saturn Emulator
    Copyright (C) 1998  Chuck Mason

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Chuck Mason IV                      chuckjr@sundial.net
    477 Moffat Loop
    Oviedo, Fl 32765
*/

#ifndef __GAME_H
#define __GAME_H

#include "header.h"

typedef struct __saturn_game {
	saturn_header header;

	unsigned char security_code[SECURITY_CODE_LEN];
	unsigned char area_codes[AREA_CODE_LEN * 8]; /* 8 area codes 32 bytes each */
	unsigned char application_initial_program[APPLICATION_INITIAL_PROGRAM_SIZE];
		
	int max_cds;
	int current_cd;
} saturn_game, *saturn_game_ptr;

extern saturn_game current_game;
 
#endif
	