/* 
	This program will not compile on your machine.
	It requires two things: the sh2 cpu and the headers.
	
	I provided this file to proove that I am indeed working on this
	with intentions

	I left all the debugging information in just for the heck of it.
		
	-Chuck Mason
	chuckjr@sundial.net
*/

#include <stdio.h>
#include <stdlib.h>
#include "opcodes.h"
#include "sh2proc.h"

int main(int argc, char *argv[])
{
	FILE *fp;	
	unsigned long len, i;

	printf("SH-2 CPU Test by Chuck Mason (chuckjr@sundial.net)\n");
	printf("This CPU core is part of semu. This program was made\n");
	printf("to demonstrate the progress that I am having with semu.\n");

	if(argc != 2) {
		printf("\nUsage: %s [rom file]\n", argv[0]);
		printf("[rom file] can be any kind of file. This program will\n");
		printf("try to execute it in the sh2 cpu.\n");
		return 1;
	}
	
	if((fp = fopen(argv[1], "rb")) == NULL) {
		printf("Cannot open %s!\n", argv[1]);
		return 1;
	}
	
	fseek(fp, 0, SEEK_END);
	len = ftell(fp);
	rewind(fp);
	
	for(i = 1; i <= len; i++) {
		unsigned char c;
		c = fgetc(fp);
		sh2_write_byte(i - 1, c);
	}
	
	fclose(fp);
	
	build_instruction_list();
	PC = 0;	
	SR = 0;
	
	while(sh2_invlalid_opcode_occ != 1 && PC != len) {
		printf("%08X %04X: ", PC, sh2_read_word(PC));
		execute_instruction(sh2_read_word(PC));
	}
	return 0;
}
